#include <stdio.h>

typedef struct { double x, y; } point;

void xchg(void *a, size_t i, size_t j)
{
	point *arr = (point *)a;
	point tmp = arr[i];
	arr[i] = arr[j];
	arr[j] = tmp;
}

int comp_by_x_asc(void *a, size_t i, size_t j)
{
	point *arr = (point *)a;
	return arr[i].x > arr[j].x;
}

typedef void xchg_fp(void *, size_t, size_t);
typedef int comp_fp(void *, size_t, size_t);

void bubble(void *t, size_t n, comp_fp comp, xchg_fp xchg)
{
	size_t iter, i;
	for (iter = 0; iter < n-1; ++iter)
		for (i = 0; i < n-iter-1; ++i)
			if (comp(t, i, i+1))
				xchg(t, i, i+1);
}

int main(void)
{
	size_t i;
	point p[] = {{0.0,0.0}, {1.0,0.0}, {-2.0,5.0}};
	bubble(p, 3, comp_by_x_asc, xchg);
	for (i = 0; i < 3; ++i)
		printf("(%f %f)\n", p[i].x, p[i].y);
	return 0;
}
